EXE = exercise4_27
C_FLAGS = -Wall -Wextra -Werror -g3
Program = exercise4_27

dbg: debug/$(EXE)

debug/$(EXE): debug/$(Program).o
	g++    $(C_FLAGS) $^ -o $@

debug/$(Program).o: debug/$(Program).s
	g++ -c $(C_FLAGS) $^ -o $@

debug/$(Program).s: debug/$(Program).ii
	g++ -S $(C_FLAGS) $^ -o $@

debug/$(Program).ii: $(Program).cpp
	g++ -E $(C_FLAGS) $^ -o $@

debug/$(Program).ii: | debug

debug:
	mkdir -p debug

clean:
	rm -rf debug *.ii *.s *.o *.out

test1: debug/$(EXE)
	@./debug/$(EXE) < test1.in > test1.out || echo "Test 1 is executing..."
	@diff test1.out test1.expected && echo "\nTEST 1 PASSED\n" || echo "\nTEST 1 FAILED\n"

test2: debug/$(EXE)
	@./debug/$(EXE) < test2.in > test2.out || echo "Test 2 is executing..."
	@diff test2.out test2.expected && echo "\nTEST 2 PASSED\n" || echo "\nTEST 2 FAILED\n"

test3: debug/$(EXE)
	@./debug/$(EXE) < test3.in > test3.out || echo "Test 3 is executing..."
	@diff test3.out test3.expected && echo "\nTEST 3 PASSED\n" || echo "\nTEST 3 FAILED\n"

.PRECIOUS: $(Program).ii $(Program).s
.SECONDARY: $(Program).ii $(Program).s

